function derivatives = evalBSplineDeriv(knots, degree, eta)
% 
% 

    m = numel(knots) - degree - 1;

    derivatives = zeros(m, length(eta));
    
    % recursive calculation of B-Spline values
    if degree == 0
        % all derivatives zero, do nothing
    else
        prevSplines = evalBSpline(knots, degree-1, eta);
        for i = 1:m
            if knots(i+degree) > knots(i)
                derivatives(i, :) = degree / (knots(i+degree) - knots(i)) .* prevSplines(i, :);
            end
            if knots(i+degree+1) > knots(i+1)
                derivatives(i, :) = derivatives(i, :) - degree / (knots(i+degree+1) - knots(i+1)) .* prevSplines(i+1, :);
            end
        end
    end
    %derivatives = sparse(derivatives);
end
    