function Nsplines = evalNURBS(knots, degree, weights, eta)
% EVALBSPLINE Evaluate all B-Spline basis functions in a number of points.
%
% The number of splines is numel(knots)-degree-1.
% splines(i,j) = value of i-th basis function, evaluated in eta(j).

splines = evalBSpline(knots, degree, eta);

Nsplines = splines.*weights./(splines'*weights)';

end