function [H, opt] = univariateIntegralTGauss(H, opt)
%UNTITLED Summary of this function goes here
%   Detailed eYplanation goes here
if nargin < 2
    opt = struct();
end
if ~isfield(opt, 'quadSize') || isempty(opt.quadSize)
    opt.quadSize = 100;
end

n = numel(H.geometry.tensor.knots{2}) - H.geometry.tensor.degree(2) - 1;
% Gauss quadrature with 5 points on each nonempty knot span
s = [-0.906179845938664, -0.538469310105683, 0, 0.538469310105683, 0.906179845938664];
w = [0.236926885056189, 0.478628670499366, 0.568888888888889, 0.478628670499366, 0.236926885056189]';
        
if opt.stiffness == 1
    H.stiffness.Y = zeros(n,n,max(H.stiffness.R), 4);
end
if opt.mass == 1
    H.mass.Y = zeros(n,n,H.mass.R);
end

for l = 1:length(H.geometry.knots{2})-1
    if H.geometry.tensor.knots{2}(l) < H.geometry.tensor.knots{2}(l+1)
        a = H.geometry.tensor.knots{2}(l);
        b = H.geometry.tensor.knots{2}(l+1);
        YY = (b-a)/2*s + (a+b)/2;
        quadValues = evalNURBS(H.geometry.tensor.knots{2}, H.geometry.tensor.degree(2), H.geometry.tensor.Tweights{2}', YY);
        quadValues2 = evalNURBS(H.weightFun.knots{2}, H.weightFun.degree(2), H.weightFun.weight{2}', YY);
        quadValuesDeriv = evalNURBSDeriv(H.geometry.tensor.knots{2}, H.geometry.tensor.degree(2), H.geometry.tensor.Tweights{2}', YY);
        for i = l-H.geometry.tensor.degree(2):l
            for j = l-H.geometry.tensor.degree(2):l
                for k = 1:length(s)
                    if opt.stiffness == 1
                        for r = 1:H.stiffness.R(1)
                            H.stiffness.Y(i,j,r,1) = H.stiffness.Y(i,j,r,1) + ((b-a)/2)*w(k)*quadValues(i,k)*quadValues(j,k)*quadValues2(:,k)'*H.stiffness.SVDV(:,r,1)*H.stiffness.SVDWeights(r,1);
                        end
                        for r = 1:H.stiffness.R(2)
                            H.stiffness.Y(i,j,r,2) = H.stiffness.Y(i,j,r,2) + ((b-a)/2)*w(k)*quadValues(i,k)*quadValuesDeriv(j,k)*quadValues2(:,k)'*H.stiffness.SVDV(:,r,2)*H.stiffness.SVDWeights(r,2);
                            H.stiffness.Y(i,j,r,3) = H.stiffness.Y(i,j,r,3) + ((b-a)/2)*w(k)*quadValuesDeriv(i,k)*quadValues(j,k)*quadValues2(:,k)'*H.stiffness.SVDV(:,r,2)*H.stiffness.SVDWeights(r,2);
                        end
                        for r = 1:H.stiffness.R(3)
                            H.stiffness.Y(i,j,r,4) = H.stiffness.Y(i,j,r,4) + ((b-a)/2)*w(k)*quadValuesDeriv(i,k)*quadValuesDeriv(j,k)*quadValues2(:,k)'*H.stiffness.SVDV(:,r,3)*H.stiffness.SVDWeights(r,3);
                        end
                    end
                    if opt.mass ==1
                        for r = 1:H.mass.R
                            H.mass.Y(i,j,r) = H.mass.Y(i,j,r) + ((b-a)/2)*w(k)*quadValues(i,k)*quadValues(j,k)*quadValues2(:,k)'*H.mass.SVDV(:,r)*H.mass.SVDWeights(r);
                        end
                    end
                end
            end
        end
    end
end


end