function [rhs] = univariateIntegralXf(rhs)

n = rhs.geometry.n(1);
s = [-0.906179845938664, -0.538469310105683, 0, 0.538469310105683, 0.906179845938664];
w = [0.236926885056189, 0.478628670499366, 0.568888888888889, 0.478628670499366, 0.236926885056189]';

rhs.X = zeros(n,rhs.R(1));

for l=1:length(rhs.geometry.knots{1})-1
    if rhs.geometry.knots{1}(l) < rhs.geometry.knots{1}(l+1)
        a = rhs.geometry.knots{1}(l);
        b = rhs.geometry.knots{1}(l+1);
        xx = (b-a)/2*s + (a+b)/2;
        quadValues = evalNURBS(rhs.geometry.knots{1}, rhs.geometry.degree(1), rhs.geometry.Tweights{1}',xx);
        quadValues2 = evalNURBS(rhs.weightFun.knots{1}, rhs.weightFun.degree(1), rhs.weightFun.weight{1}', xx);
        for i = l-rhs.geometry.degree(1):l
            for k = 1:length(s)
                for r = 1:rhs.R(1)
                    rhs.X(i,r) = rhs.X(i,r) + ((b-a)/2)*w(k)*quadValues(i,k)*quadValues2(:,k)'*rhs.SVDU{1}(:,r);
                end
            end
        end
    end
end


end