function [rhs] = univariateIntegralZf(rhs)

n = rhs.geometry.n(3);
s = [-0.906179845938664, -0.538469310105683, 0, 0.538469310105683, 0.906179845938664];
w = [0.236926885056189, 0.478628670499366, 0.568888888888889, 0.478628670499366, 0.236926885056189]';

rhs.Z = zeros(n,rhs.R(3));

for l=1:length(rhs.geometry.knots{3})-1
    if rhs.geometry.knots{3}(l) < rhs.geometry.knots{3}(l+1)
        a = rhs.geometry.knots{3}(l);
        b = rhs.geometry.knots{3}(l+1);
        xx = (b-a)/2*s + (a+b)/2;
        quadValues = evalNURBS(rhs.geometry.knots{3}, rhs.geometry.degree(3), rhs.geometry.Tweights{3}',xx);
        quadValues2 = evalNURBS(rhs.weightFun.knots{3}, rhs.weightFun.degree(3), rhs.weightFun.weight{3}', xx);
        for i = l-rhs.geometry.degree(3):l
            for k = 1:length(s)
                for r = 1:rhs.R(3)
                    rhs.Z(i,r) = rhs.Z(i,r) + ((b-a)/2)*w(k)*quadValues(i,k)*quadValues2(:,k)'*rhs.SVDU{3}(:,r);
                end
            end
        end
    end
end


end