function p = plotNDomain(G, color, p )

xx = linspace(0,G.knots{1}(end),11);
yy = linspace(0,G.knots{2}(end),101);
x1 = evalBSpline(G.knots{1}, G.degree(1),xx);
y1 = evalBSpline(G.knots{2}, G.degree(2), yy);

X = x1'*(G.controlPoints(:,:,1).*G.weight)*y1./(x1'*G.weight*y1);
Y = x1'*(G.controlPoints(:,:,2).*G.weight)*y1./(x1'*G.weight*y1);

if nargin < 3
    p = figure;
end

hold on
plot(X',Y', color, 'lineWidth', 2)

xx = linspace(0,G.knots{2}(end),11);
yy = linspace(0,G.knots{1}(end),101);
x2 = evalBSpline(G.knots{1}, G.degree(1), yy);
y2 = evalBSpline(G.knots{2}, G.degree(2), xx);
X2 = x2'*(G.controlPoints(:,:,1).*G.weight)*y2./(x2'*G.weight*y2);
Y2 = x2'*(G.controlPoints(:,:,2).*G.weight)*y2./(x2'*G.weight*y2);

plot(X2, Y2, color, 'lineWidth', 2);
plot(G.controlPoints(:,:,1), G.controlPoints(:,:,2), 'ob', 'markerSize', 10, 'lineWidth', 2);
end