function p = plotNLines3(G, color, p )
a = 100;
b = 100;
c = 100;
xx = linspace(0,G.knots{1}(end),a);
yy = linspace(0,G.knots{2}(end),b);
zz = linspace(0,G.knots{3}(end),c);

y1 = evalBSpline(G.knots{1}, G.degree(1),xx);
y2 = evalBSpline(G.knots{2}, G.degree(2), yy);
y3 = evalBSpline(G.knots{3}, G.degree(3), zz);

weight = reshape(G.weight, prod(G.n),1);
controlPoints = reshape(G.controlPoints, prod(G.n),3);
X1  = zeros(c,a,2);
Y1 = zeros(c,a,2);
Z1 = zeros(c,a,2);
X2 = zeros(b,a,2);
Y2 = zeros(b,a,2);
Z2 = zeros(b,a,2);
X3 = zeros(b,c,2);
Y3 = zeros(b,c,2);
Z3 = zeros(b,c,2);
for i = 1:a
    for k = 1:c
        X1(k,i,1) = ((kron(y3(:,k),kron(y2(:,1),y1(:,i))).*weight)./(kron(y3(:,k),kron(y2(:,1),y1(:,i)))'*weight))'*controlPoints(:,1);
        Y1(k,i,1) = ((kron(y3(:,k),kron(y2(:,1),y1(:,i))).*weight)./(kron(y3(:,k),kron(y2(:,1),y1(:,i)))'*weight))'*controlPoints(:,2);
        Z1(k,i,1) = ((kron(y3(:,k),kron(y2(:,1),y1(:,i))).*weight)./(kron(y3(:,k),kron(y2(:,1),y1(:,i)))'*weight))'*controlPoints(:,3);
        X1(k,i,2) = ((kron(y3(:,k),kron(y2(:,end),y1(:,i))).*weight)./(kron(y3(:,k),kron(y2(:,end),y1(:,i)))'*weight))'*controlPoints(:,1);
        Y1(k,i,2) = ((kron(y3(:,k),kron(y2(:,end),y1(:,i))).*weight)./(kron(y3(:,k),kron(y2(:,end),y1(:,i)))'*weight))'*controlPoints(:,2);
        Z1(k,i,2) = ((kron(y3(:,k),kron(y2(:,end),y1(:,i))).*weight)./(kron(y3(:,k),kron(y2(:,end),y1(:,i)))'*weight))'*controlPoints(:,3);
    end
    for j = 1:b
        X2(j,i,1) = ((kron(y3(:,1),kron(y2(:,j),y1(:,i))).*weight)./(kron(y3(:,1),kron(y2(:,j),y1(:,i)))'*weight))'*controlPoints(:,1);
        Y2(j,i,1) = ((kron(y3(:,1),kron(y2(:,j),y1(:,i))).*weight)./(kron(y3(:,1),kron(y2(:,j),y1(:,i)))'*weight))'*controlPoints(:,2);
        Z2(j,i,1) = ((kron(y3(:,1),kron(y2(:,j),y1(:,i))).*weight)./(kron(y3(:,1),kron(y2(:,j),y1(:,i)))'*weight))'*controlPoints(:,3);
        X2(j,i,2) = ((kron(y3(:,end),kron(y2(:,j),y1(:,i))).*weight)./(kron(y3(:,end),kron(y2(:,j),y1(:,i)))'*weight))'*controlPoints(:,1);
        Y2(j,i,2) = ((kron(y3(:,end),kron(y2(:,j),y1(:,i))).*weight)./(kron(y3(:,end),kron(y2(:,j),y1(:,i)))'*weight))'*controlPoints(:,2);
        Z2(j,i,2) = ((kron(y3(:,end),kron(y2(:,j),y1(:,i))).*weight)./(kron(y3(:,end),kron(y2(:,j),y1(:,i)))'*weight))'*controlPoints(:,3);
    end
end
for j = 1:b
    for k = 1:c
        X3(j,k,1) = ((kron(y3(:,k),kron(y2(:,j),y1(:,1))).*weight)./(kron(y3(:,k),kron(y2(:,j),y1(:,1)))'*weight))'*controlPoints(:,1);
        Y3(j,k,1) = ((kron(y3(:,k),kron(y2(:,j),y1(:,1))).*weight)./(kron(y3(:,k),kron(y2(:,j),y1(:,1)))'*weight))'*controlPoints(:,2);
        Z3(j,k,1) = ((kron(y3(:,k),kron(y2(:,j),y1(:,1))).*weight)./(kron(y3(:,k),kron(y2(:,j),y1(:,1)))'*weight))'*controlPoints(:,3);
        X3(j,k,2) = ((kron(y3(:,k),kron(y2(:,j),y1(:,end))).*weight)./(kron(y3(:,k),kron(y2(:,j),y1(:,end)))'*weight))'*controlPoints(:,1);
        Y3(j,k,2) = ((kron(y3(:,k),kron(y2(:,j),y1(:,end))).*weight)./(kron(y3(:,k),kron(y2(:,j),y1(:,end)))'*weight))'*controlPoints(:,2);
        Z3(j,k,2) = ((kron(y3(:,k),kron(y2(:,j),y1(:,end))).*weight)./(kron(y3(:,k),kron(y2(:,j),y1(:,end)))'*weight))'*controlPoints(:,3);
    end
end

if nargin < 3
    p = figure;
end
hold on
plot3(X1(1,:,1), Y1(1,:,1), Z1(1,:,1), color,'linewidth', 2);
plot3(X1(end,:,1), Y1(end,:,1), Z1(end,:,1), color,'linewidth', 2);
plot3(X1(:,1,1), Y1(:,1,1), Z1(:,1,1), color,'linewidth', 2);
plot3(X1(:,end,1), Y1(:,end,1), Z1(:,end,1), color,'linewidth', 2);
plot3(X1(1,:,2), Y1(1,:,2), Z1(1,:,2), color,'linewidth', 2);
plot3(X1(end,:,2), Y1(end,:,2), Z1(end,:,2), color,'linewidth', 2);
plot3(X1(:,1,2), Y1(:,1,2), Z1(:,1,2), color,'linewidth', 2);
plot3(X1(:,end,2), Y1(:,end,2), Z1(:,end,2), color,'linewidth', 2);
plot3(X2(1,:,1), Y2(1,:,1), Z2(1,:,1), color,'linewidth', 2);
plot3(X2(end,:,1), Y2(end,:,1), Z2(end,:,1), color,'linewidth', 2);
plot3(X2(:,1,1), Y2(:,1,1), Z2(:,1,1), color,'linewidth', 2);
plot3(X2(:,end,1), Y2(:,end,1), Z2(:,end,1), color,'linewidth', 2);
plot3(X2(1,:,2), Y2(1,:,2), Z2(1,:,2), color,'linewidth', 2);
plot3(X2(end,:,2), Y2(end,:,2), Z2(end,:,2), color,'linewidth', 2);
plot3(X2(:,1,2), Y2(:,1,2), Z2(:,1,2), color,'linewidth', 2);
plot3(X2(:,end,2), Y2(:,end,2), Z2(:,end,2), color,'linewidth', 2);
plot3(X3(1,:,1), Y3(1,:,1), Z3(1,:,1), color,'linewidth', 2);
plot3(X3(end,:,1), Y3(end,:,1), Z3(end,:,1), color,'linewidth', 2);
plot3(X3(:,1,1), Y3(:,1,1), Z3(:,1,1), color,'linewidth', 2);
plot3(X3(:,end,1), Y3(:,end,1), Z3(:,end,1), color,'linewidth', 2);
plot3(X3(1,:,2), Y3(1,:,2), Z3(1,:,2), color,'linewidth', 2);
plot3(X3(end,:,2), Y3(end,:,2), Z3(end,:,2), color,'linewidth', 2);
plot3(X3(:,1,2), Y3(:,1,2), Z3(:,1,2), color,'linewidth', 2);
plot3(X3(:,end,2), Y3(:,end,2), Z3(:,end,2), color,'linewidth', 2);

%plot(X,Z, 'black', 'lineWidth', 2)
%  plot3(X',Y',Z', color, 'lineWidth', 2)

end