function p= plotNSol(H, x, xhat, t, p)

a = 40;
b = 40;
c = 40;

weight = reshape(H.geometry.weight, prod(H.geometry.n),1);
controlPoints = reshape(H.geometry.controlPoints, prod(H.geometry.n),3);


sol = zeros(size(weight));
sol2 = zeros(size(weight));
if numel(x) == prod(H.geometry.n)
    sol = x;
    sol2 = xhat;
elseif numel(x) == prod(H.geometry.n-2)
    sol(logical(kron(H.boundary.zInner, kron(H.boundary.yInner, H.boundary.xInner)))) = x;
    sol2(logical(kron(H.boundary.zInner, kron(H.boundary.yInner, H.boundary.xInner)))) = xhat;
end
xx = linspace(0, H.geometry.knots{1}(end),a);
yy = linspace(0, H.geometry.knots{2}(end),b);
zz = linspace(0, H.geometry.knots{3}(end),c);

y1 = evalBSpline(H.geometry.knots{1}, H.geometry.degree(1),xx);
y2 = evalBSpline(H.geometry.knots{2}, H.geometry.degree(2), yy);
y3 = evalBSpline(H.geometry.knots{3}, H.geometry.degree(3), zz);

if nargin < 4
    p = figure;
end
subplot(1,2,1)
hold on;
X = reshape(((kron(y3,kron(y2,y1(:,20))).*weight)'./(kron(y3,kron(y2,y1(:,20)))'*weight))*controlPoints(:,1),b,c);
Y = reshape(((kron(y3,kron(y2,y1(:,20))).*weight)'./(kron(y3,kron(y2,y1(:,20)))'*weight))*controlPoints(:,2),b,c);
Z = reshape(((kron(y3,kron(y2,y1(:,20))).*weight)'./(kron(y3,kron(y2,y1(:,20)))'*weight))*controlPoints(:,3),b,c);
val = reshape(((kron(y3, kron(y2,y1(:,20))).*weight)'./(kron(y3,kron(y2,y1(:,20)))'*weight))*sol,b,c);
surf(X,Y,Z,val);
title('Solution')
subplot(1,2,2)
hold on
val2 = reshape(((kron(y3, kron(y2,y1(:,20))).*weight)'./(kron(y3,kron(y2,y1(:,20)))'*weight))*sol2,b,c);
% val2 = ysol(X,Y,Z,t);
surf(X,Y,Z,val2);
title('Desired state')

for i = 10:10:30
    subplot(1,2,1)
    hold on;
    X = reshape(((kron(y3,kron(y2(:,i),y1)).*weight)'./(kron(y3,kron(y2(:,i),y1))'*weight))*controlPoints(:,1),a,c);
    Y = reshape(((kron(y3,kron(y2(:,i),y1)).*weight)'./(kron(y3,kron(y2(:,i),y1))'*weight))*controlPoints(:,2),a,c);
    Z = reshape(((kron(y3,kron(y2(:,i),y1)).*weight)'./(kron(y3,kron(y2(:,i),y1))'*weight))*controlPoints(:,3),a,c);
    val = reshape(((kron(y3,kron(y2(:,i),y1)).*weight)'./(kron(y3,kron(y2(:,i),y1))'*weight))*sol,a,c);
    surf(X,Y,Z,val);
    subplot(1,2,2)
    hold on
    val2 = reshape(((kron(y3,kron(y2(:,i),y1)).*weight)'./(kron(y3,kron(y2(:,i),y1))'*weight))*sol2,a,c);
    surf(X,Y,Z,val2);
end

for i = 10:20:30
    subplot(1,2,1)
    hold on;
    X = reshape(((kron(y3(:,i),kron(y2,y1)).*weight)'./(kron(y3(:,i),kron(y2,y1))'*weight))*controlPoints(:,1),a,b);
    Y = reshape(((kron(y3(:,i),kron(y2,y1)).*weight)'./(kron(y3(:,i),kron(y2,y1))'*weight))*controlPoints(:,2),a,b);
    Z = reshape(((kron(y3(:,i),kron(y2,y1)).*weight)'./(kron(y3(:,i),kron(y2,y1))'*weight))*controlPoints(:,3),a,b);
    val = reshape(((kron(y3(:,i),kron(y2,y1)).*weight)'./(kron(y3(:,i),kron(y2,y1))'*weight))*sol,a,b);
    surf(X,Y,Z,val);
    subplot(1,2,2)
    hold on
    val2 = reshape(((kron(y3(:,i),kron(y2,y1)).*weight)'./(kron(y3(:,i),kron(y2,y1))'*weight))*sol2,a,c);
    surf(X,Y,Z,val2);
end
colorbar
end

