function  plotNURBS(H)
%PLOTBSPLINE Summary of this function goes here
%   Detailed explanation goes here


h = 100;
gridS = linspace(0,1,h);
gridT = linspace(0,1,h);

evalS = evalNURBS(H.geometry.tensor.knots{1}, H.geometry.tensor.degree(1), H.geometry.tensor.Tweights{1}', gridS);
evalT = evalNURBS(H.geometry.tensor.knots{2}, H.geometry.tensor.degree(2), H.geometry.tensor.Tweights{2}', gridT);

X = zeros(h,h);
Y = zeros(h,h);
Z = zeros(h,h);
Z2 = zeros(h,h);
for i = 1:h
    for j = 1:h
        X(i,j) = evalS(:,i)'*H.geometry.tensor.controlPoints(:,:,1)*evalT(:,j);
        Y(i,j) = evalS(:,i)'*H.geometry.tensor.controlPoints(:,:,2)*evalT(:,j);
        Z(i,j) = evalS(:,i)'*H.sol*evalT(:,j);
        if isfield('solAnalytic', H)
%             Z2(i,j) = solAnalytic(X(i,j),Y(i,j));
        end
    end
end
figure;

if isfield('solAnalytic', H)
    subplot(1,2,1)
    mesh(X,Y,Z);
    title('Solution');
    subplot(1,2,2)
    mesh(X,Y,abs(Z-Z2));
    title('Absolute error to analytic solution')
    fprintf('mean error: %d \n', sum(sum(abs(Z-Z2)))/(h^2));
else
    mesh(X,Y,Z);
    title('Solution')
end