function vtkNURBS(H,x, name)

a = 40;
b = 40;
c = 40;
weight = reshape(H.geometry.weight, prod(H.geometry.n),1);
controlPoints = reshape(H.geometry.controlPoints, prod(H.geometry.n),3);

% 
sol = zeros(size(weight));
sol(logical(kron(H.boundary.zInner, kron(H.boundary.yInner, H.boundary.xInner)))) = x;


xx = linspace(0, H.geometry.knots{1}(end),a);
yy = linspace(0, H.geometry.knots{2}(end),b);
zz = linspace(0, H.geometry.knots{3}(end),c);

y1 = evalBSpline(H.geometry.knots{1}, H.geometry.degree(1),xx);
y2 = evalBSpline(H.geometry.knots{2}, H.geometry.degree(2), yy);
y3 = evalBSpline(H.geometry.knots{3}, H.geometry.degree(3), zz);

X = reshape(((kron(y3,kron(y2,y1)).*weight)'./(kron(y3,kron(y2,y1))'*weight))*controlPoints(:,1),a, b,c);
Y = reshape(((kron(y3,kron(y2,y1)).*weight)'./(kron(y3,kron(y2,y1))'*weight))*controlPoints(:,2),a, b,c);
Z = reshape(((kron(y3,kron(y2,y1)).*weight)'./(kron(y3,kron(y2,y1))'*weight))*controlPoints(:,3),a, b,c);
val = reshape(((kron(y3, kron(y2,y1)).*weight)'./(kron(y3,kron(y2,y1))'*weight))*sol,a, b, c);


vtkwrite(name, 'structured_grid', X, Y, Z, 'scalars','sol', val,'precision',5);


end